
/******************************************************************************
* MODULE     : distribution_test.cc
* DESCRIPTION: Test distributions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "distribution.hpp"
using namespace mmx;

template<typename C> void
random_sequence (const distribution<C>& db, nat n) {
  for (nat i=0; i<n; i++)
    cout << "  " << i << ":\t" << db() << "\n";
}

int
main () {
  distribution<double> u= uniform (1.0);
  distribution<double> v= uniform (10.0);
  distribution<double> w= u+v;
  cout << "u= " << u << " ->\n";
  random_sequence (u, 10);
  cout << "v= " << v << " ->\n";
  random_sequence (v, 10);
  cout << "w= " << w << " ->\n";
  random_sequence (w, 10);
  return 0;
}
