
/******************************************************************************
* MODULE     : fkt_test.cc
* DESCRIPTION: Test "fast Karatsuba transforms"
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rational.hpp"
#include "karatsuba.hpp"
using namespace mmx;

#define C rational

int
main () {
  /*
  C buf_f[3]; buf_f[0]= 1; buf_f[1]= 2;
  C buf_g[3]; buf_g[0]= 3; buf_g[1]= 4;
  cout << "f: "; segment_print (cout, buf_f, 2); cout << "\n";
  cout << "g: "; segment_print (cout, buf_g, 2); cout << "\n";
  direct_fkt (buf_f, 2, 3);
  direct_fkt (buf_g, 2, 3);
  cout << "Kf: "; segment_print (cout, buf_f, 3); cout << "\n";
  cout << "Kg: "; segment_print (cout, buf_g, 3); cout << "\n";
  C buf_h[3];
  for (nat i=0; i<3; i++) buf_h[i]= buf_f[i] * buf_g[i];
  cout << "Kh: "; segment_print (cout, buf_h, 3); cout << "\n";
  inverse_fkt (buf_h, 3, 2);
  cout << "h: "; segment_print (cout, buf_h, 3); cout << "\n";
  */

  C buf_f[9]; buf_f[0]= 1; buf_f[1]= 2; buf_f[2]= 3; buf_f[3]= 4;
  C buf_g[9]; buf_g[0]= 3; buf_g[1]= 4; buf_g[2]= 0; buf_g[3]= 1;
  cout << "f: "; segment_print (cout, buf_f, 4); cout << "\n";
  cout << "g: "; segment_print (cout, buf_g, 4); cout << "\n";
  direct_fkt (buf_f, 4, 9);
  direct_fkt (buf_g, 4, 9);
  cout << "Kf: "; segment_print (cout, buf_f, 9); cout << "\n";
  cout << "Kg: "; segment_print (cout, buf_g, 9); cout << "\n";
  C buf_h[9];
  for (nat i=0; i<9; i++) buf_h[i]= buf_f[i] * buf_g[i];
  cout << "Kh: "; segment_print (cout, buf_h, 9); cout << "\n";
  inverse_fkt (buf_h, 9, 4);
  cout << "h: "; segment_print (cout, buf_h, 7); cout << "\n";

  /*
  C buf_f[27]; for (nat i=0; i<8; i++) buf_f[i]= 1;
  C buf_g[27]; for (nat i=0; i<8; i++) buf_g[i]= 1;
  cout << "f: "; segment_print (cout, buf_f, 8); cout << "\n";
  cout << "g: "; segment_print (cout, buf_g, 8); cout << "\n";
  direct_fkt (buf_f, 8, 27);
  direct_fkt (buf_g, 8, 27);
  cout << "Kf: "; segment_print (cout, buf_f, 27); cout << "\n";
  cout << "Kg: "; segment_print (cout, buf_g, 27); cout << "\n";
  C buf_h[27];
  for (nat i=0; i<27; i++) buf_h[i]= buf_f[i] * buf_g[i];
  cout << "Kh: "; segment_print (cout, buf_h, 27); cout << "\n";
  inverse_fkt (buf_h, 27, 8);
  cout << "h: "; segment_print (cout, buf_h, 15); cout << "\n";
  */

  return 0;
}
