
/******************************************************************************
* MODULE     : complexify_interval.hpp
* DESCRIPTION: Complexified intervals
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_COMPLEXIFY_INTERVAL_HPP
#define __MMX_COMPLEXIFY_INTERVAL_HPP
#include "interval.hpp"
#include "complexify.hpp"
namespace mmx {
#define TMPL template<typename C>
#define Interval interval<C>
#define Complexify complexify<C>
#define Complexify_interval complexify<interval<C> >

TMPL
struct make_ball_helper<Complexify_interval,Complexify,C> {
  static inline Complexify_interval val (const Complexify& c, const C& r) {
    return Complexify_interval (make_ball<Interval,C,C> (Re (c), r),
				make_ball<Interval,C,C> (Im (c), r)); }
};

TMPL inline C abs_D (const Complexify_interval& z) { return lower (abs (z)); }
TMPL inline C abs_U (const Complexify_interval& z) { return upper (abs (z)); }

#undef TMPL
#undef Interval
#undef Complexify
#undef Complexify_interval
} // namespace mmx
#endif // __MMX_COMPLEXIFY_HPP
