
/******************************************************************************
* MODULE     : floating_glue.cpp
* DESCRIPTION: Standard glue for floating point numbers
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "floating_meta.hpp"
#include "category_glue.hpp"
#include "literal.hpp"
namespace mmx {

template<typename T> T
make_literal (const literal& lit) {
  return *lit;
}

void
define_floating () {
  define_type<always,floating<> > ("Floating");
  define<always> ("literal_floating", make_literal<floating<> >);
  define_field<always,floating<> > ();
  define_elementary<always,floating<> > ();
  define_ordering<always,floating<> > ();
}

} // namespace mmx
