
/******************************************************************************
* MODULE     : timer.cpp
* DESCRIPTION: timers
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "basix.hpp"

namespace mmx {

#ifdef HAVE_GETTIMEOFDAY
#include <sys/time.h>
#else
#include <sys/timeb.h>
#endif

#include <sys/resource.h>

nat
mmx_time () {
#ifdef HAVE_GETTIMEOFDAY
  struct timeval tp;
  gettimeofday (&tp, NULL);
  return (nat) ((time_t) ((tp.tv_sec * 1000) + (tp.tv_usec / 1000)));
#else
  timeb tb;
  ftime (&tb);
  return (nat) ((time_t) ((tb.time * 1000) + tb.millitm));
#endif
}

nat
mmx_user_time(void) {
  struct rusage used;
  getrusage(RUSAGE_SELF, &used);
  return (nat) ((time_t) ((used.ru_utime.tv_sec * 1000) + (used.ru_utime.tv_usec / 1000)));
}

} // namespace mmx
