
/******************************************************************************
* MODULE     : string.cpp
* DESCRIPTION: Strings with possible zero characters
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include <string.h>
namespace mmx {

string::string (char c) {
  rep= new string_rep(1);
  rep->a[0]=c;
}

string::string (char *a) {
  register nat i, n=strlen(a);
  rep= new string_rep(n);
  for (i=0; i<n; i++)
    rep->a[i]=a[i];
}

string::string (char* a, nat n) {
  register nat i;
  rep= new string_rep(n);
  for (i=0; i<n; i++)
    rep->a[i]=a[i];
}

void
string_rep::resize (nat new_size) {
  if (new_size > l) {
    register nat old_l= l;
    l= max (l << 1, new_size);
    char* b= (char*) mmx_malloc (l);
    for (nat i=0; i<n; i++)
      b[i]= a[i];
    mmx_free ((void*) a, old_l);
    a= b;
  }
  n= new_size;
}

} // namespace mmx
