
/******************************************************************************
* MODULE     : string_match.cpp
* DESCRIPTION: Tests for matching starts or ends
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
namespace mmx {

bool
starts (const string& s, const string& what) {
  return N(s) >= N(what) && s (0, N(what)) == what;
}

bool
ends (const string& s, const string& what) {
  return N(s) >= N(what) && s (N(s) - N(what), N(s)) == what;
}

} // namespace mmx
