
/******************************************************************************
* MODULE     : heap_test.cc
* DESCRIPTION: Test heaps
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "heap.hpp"
using namespace mmx;

static bool
compare_int (const int& x, const int& y) {
  return x <= y;
}

int
main () {
  heap<int> h (compare_int);
  cout << "h\t= " << h << "\n";
  h << 3; cout << "Push\t: " << 3 << "\n";
  cout << "h\t= " << h << "\n";
  h << 1; cout << "Push\t: " << 1 << "\n";
  cout << "h\t= " << h << "\n";
  h << 7; cout << "Push\t: " << 7 << "\n";
  cout << "h\t= " << h << "\n";
  h << 2; cout << "Push\t: " << 2 << "\n";
  cout << "h\t= " << h << "\n";
  cout << "Pull\t: " << pull (h) << "\n";
  cout << "h\t= " << h << "\n";  
  h << 9; cout << "Push\t: " << 9 << "\n";
  cout << "h\t= " << h << "\n";
  h << 6; cout << "Push\t: " << 6 << "\n";
  cout << "h\t= " << h << "\n";
  set_top (h, 11); cout << "Set_top\t: " << 11 << "\n";
  cout << "h\t= " << h << "\n";
  heap<int> i= h;
  cout << "i\t= " << i << "\n";
  cout << "h=i\t? " << (h==i) << "\n";
  cout << "h!=i\t? " << (h!=i) << "\n";
  h << 9 << 8 << 7 << 6 << 5;
  cout << "Push\t: 9, 8, 7, 6, 5\n";
  cout << "h\t= " << h << "\n";
  cout << "h=i\t? " << (h==i) << "\n";
  cout << "h!=i\t? " << (h!=i) << "\n";  
  cout << "h...\t= " << iterate (h) << "\n";
  return 0;
}
