
/******************************************************************************
* MODULE     : standard_glue.cpp
* DESCRIPTION: Standard glue for Mathemagix
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "symbolic_glue.hpp"
#include "literal.hpp"
#include "rational.hpp"
namespace mmx {

void
define_standard () {
  define_integer ();
  define_rational ();
  define_symbolic<always,rational> ();
  define_string ();
  define_language ();
  define_standard_list ();
  define_standard_table ();
}

evaluator
standard_evaluator () {
  evaluator ev= base_evaluator ();
  select_evaluator (ev);
  define_prerequisites ();
  define_standard ();
  restore_evaluator ();
  return ev;
}

} // namespace mmx
