
/******************************************************************************
* MODULE     : alias.cpp
* DESCRIPTION: Syntactic alias type constructor
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "alias.hpp"
#include "table.hpp"
#include "routine.hpp"
namespace mmx {

void
alias_type_info (nat& id, bool& mode) {
  static table<nat,nat> t (0);
  if (mode == false) {
    mode= t->contains (id);
    id= t[id];
  }
  else {
    nat new_id= new_type_id ();
    t (new_id)= id;
    id= new_id;
  }
}

void
alias_specializer (nat id, routine& r) {
  static table<routine,nat> t;
  if (nil (r)) r= t[id];
  else t(id)= r;
}

generic
specialize_alias (const generic& a) {
  generic val= read_alias (as<alias<generic> > (a));
  routine r;
  alias_specializer (type (val), r);
  return r->apply (a);
}

void
alias_reader (nat id, routine& r) {
  static table<routine,nat> t;
  if (nil (r)) r= t[id];
  else t(id)= r;
}

generic
read_alias (const generic& a) {
  routine r;
  alias_reader (type (a), r);
  return r->apply (a);
}

void
alias_writer (nat id, routine& r) {
  static table<routine,nat> t;
  if (nil (r)) r= t[id];
  else t(id)= r;
}

generic
write_alias (const generic& a, const generic& val) {
  routine r;
  alias_writer (type (a), r);
  return r->apply (a, val);
}

} // namespace mmx
