
/******************************************************************************
* MODULE     : integer_glue.cpp
* DESCRIPTION: Standard glue for integers
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer_meta.hpp"
#include "category_glue.hpp"
#include "literal.hpp"
namespace mmx {

template<typename C> C
make_literal (const literal& lit) {
  return C (*lit);
}

void
define_integer () {
  define_type<always,integer> ("Integer");
  define<always> ("literal_integer", make_literal<integer>);
  define_euclidean_ring<always,integer> ();
  define_ordering<always,integer> ();
}

} // namespace mmx
