
/******************************************************************************
* MODULE     : lisp_extra.cpp
* DESCRIPTION: Standard output facilities and switches
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "rational.hpp"
namespace mmx {

nat      the_series_prec = 10;
nat      the_series_zt   = 25;
bool     the_series_expr = false;
void*    flatten_aux_ptr = NULL;

generic&
the_series_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= new generic ("z");
  return *ptr;
}

generic&
the_polynomial_var () {
  static generic* ptr= NULL;
  if (ptr == NULL) ptr= new generic ("x");
  return *ptr;
}

generic flatten (bool b) {
  return b? generic ("true"): generic ("false"); }
generic flatten (int i) {
  return generic (rational (i)); }
generic flatten (nat i) {
  return generic (rational (i)); }
generic flatten (unsigned long int i) {
  return generic (rational (i)); }
generic flatten (signed long int i) {
  return generic (rational (i)); }
generic flatten (float x) {
  return generic (as_string (x)); }
generic flatten (double x) {
  return generic (as_string (x)); }
generic flatten (char* s) {
  return generic (s); }
generic flatten (const string& s) {
  return generic (s); }
generic flatten (const integer& i) {
  return generic (rational (i)); }
generic flatten (const rational& r) {
  return generic (r); }

} // namespace mmx
